function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

import prettyMsFormatter from 'pretty-ms';
import NumberFormatter from '../NumberFormatter';
export default function createDurationFormatter(config = {}) {
  const {
    description,
    id,
    label,
    multiplier = 1
  } = config,
        prettyMsOptions = _objectWithoutPropertiesLoose(config, ["description", "id", "label", "multiplier"]);

  return new NumberFormatter({
    description,
    formatFunc: value => prettyMsFormatter(value * multiplier, prettyMsOptions),
    id: id != null ? id : 'duration_format',
    label: label != null ? label : "Duration formatter"
  });
}